<template>
  <el-form
    ref="normalBankTransferDepositFormRef"
    status-icon
    label-position="left"
    :model="normalBankTransferDepositFormData"
    :rules="normalBankTransferDepositRules"
    label-width="210px"
    class="p-6 cutomeClass display-form-desktop"
    :validate-on-rule-change="false"
  >
    <div
      v-if="bankTransferDepositTextInfo?.Text.length > 0"
      class="p-4 text-sm rounded bg-background5 --text4 font-normal mb-4"
      v-html="bankTransferDepositTextInfo?.Text"
    ></div>
    <h4 class="my-4 fc-primary">{{ $t("from") }}</h4>
    <h5 :class="theme === 'peru_green' ? 'text-color' : '--text4' ">{{ $t("bank") }}</h5>
    <div class="w-full pb-5" v-if="isFirstTimeDeposit">
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        group-name="peru-select-bank-name"
        class="flex flex-column flex-wrap gap-3 py-2 peru-select-bank"
      >
        <ui-radio-button
          v-for="player in playerBankOptions"
          :key="player.BankName"
          :label="player.BankName"
          :value="player.BankName"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!player.BankLogo || player.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="player.BankName"
          />
          <ui-check-button
            v-else
            style="--height: 3rem"
            :img="getImagePathBankLogo(player.BankLogo)"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <div class="w-full pb-5" v-else>
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        group-name="peru-select-bank-name"
        class="flex flex-column flex-wrap gap-3 py-2 peru-select-bank"
      >
        <ui-radio-button
          v-for="(bank, index) in playerBankAfterFirstTimeDeposit"
          :key="index"
          :label="bank.PlayerBankName"
          :value="bank.PlayerBankName"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!bank.BankLogo || bank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="bank.PlayerBankName"
          />
          <ui-check-button
            v-else
            style="--height: 3rem"
            :img="getImagePathBankLogo(bank.BankLogo)"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="
        normalBankTransferDepositFormData.selectedPlayerBankOption === 'Other'
      "
      :label="$t('bank_name')"
      prop="customizeBankName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.customizeBankName"
        v-un-focus
        type="text"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.branchNameSetting"
      :label="$t('BranchName')"
      prop="branchName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.branchName"
        v-un-focus
        type="text"
      />
    </el-form-item>
    <el-form-item 
      v-if="companyFlowSettings.bankAccountNameSetting"
      :label="$t('bank_account_name')" 
      prop="bankAccountName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountName"
        type="text"
        v-un-focus
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNameEmpty
        "
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bankAccountNumberSetting"
      :label="$t('bank_account_number')" 
      prop="bankAccountNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountNumber"
        type="text"
        v-un-focus
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNumberEmpty
        "
        oninput="this.value = this.value.replace(/[^0-9]/g, '')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bsbSetting"
      :label="$t('BSB')"
      prop="bsb"
    >
      <el-input
        maxlength="6"
        v-model="normalBankTransferDepositFormData.bsb" id="depositBSB" 
        @input="onInputValue($event, normalBankTransferDepositFormData, 'bsb')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.payIdSetting"
      :label="$t('PayID')"
      prop="payId"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.payId" id="depositPayId" 
      />
    </el-form-item>
    <el-form-item :label="$t('amount')" prop="amount">
      <el-input
        v-model="normalBankTransferDepositFormData.amount"
        oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
        v-un-focus
        :placeholder="amountPlaceholder"
      >
        <template v-if="isNeedToMultiplyByThousand" #append>000</template>
      </el-input>
      <span
        v-if="isNeedToMultiplyByThousand"
        class="order-1 mt-3 text-xs fc-hint"
        >{{
          $t(
            `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}</span
      >
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.slipUploadSetting"
      :label="$t('slip_image')"
      prop="slipUpload"
    >
      <el-upload
        ref="uploadSlipImageFRef"
        v-model="normalBankTransferDepositFormData.slipUpload"
        class="w-full upload-demo"
        :limit="1"
        :on-exceed="handleSlipImageExceed"
        accept=".jpg, .png, .jpeg, .svg"
        :on-change="getSlipImage"
        :on-remove="removeSlipImage"
        :auto-upload="false"
      >
        <el-button plain round type="primary">
          {{ $t("choose_file") }}
        </el-button>
      </el-upload>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositTimeSetting"
      class="input-class"
      :label="$t('deposit_time')"
      prop="depositTime"
    >
      <el-date-picker
        v-model="normalBankTransferDepositFormData.depositTime"
        type="datetime"
        format="YYYY-MM-DD h:mm:ss A"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositReferenceNumberSetting"
      :label="$t('reference_number')"
      prop="depositReferenceNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.depositReferenceNumber"
        type="text"
        v-un-focus
      />
      <span
        v-if="selectedTheme === 'black'"
        class="order-1 mt-3 text-xs fc-hint"
        >{{ $t("reference_number_remark") }}</span
      >
    </el-form-item>
    <h4 class="mb-4 mt-8 fc-primary">{{ $t("to") }}</h4>
    <h5 :class="theme === 'peru_green' ? 'text-color' : '--text4' ">{{ $t("company_bank") }}</h5>
    <div class="pb-5 w-full">
      <ui-radio-group
        v-model="selectedCompanyBankId"
        class="flex flex-column flex-wrap gap-3 peru-select-bank py-2"
        group-name="peru-select-company-bank-name"
      >
        <ui-radio-button
          v-for="companyBank in CompanyBanks"
          :key="companyBank.BankName"
          :label="companyBank.Id"
          :value="companyBank.Id"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!companyBank.BankLogo || companyBank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="companyBank.BankName"
          />
          <ui-check-button
            v-else
            :img="getImagePathBankLogo(companyBank.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="companyFlowSettings.companyBankAccountNameSetting"
      :label="$t('CompanyBankAccountName')"
      prop="companyBankAccountName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountName"
        type="text"
        :disabled="true"
      />
    </el-form-item>
    <el-form-item
      :label="$t('bank_account')"
      prop="companyBankAccountNumber"
      class="company-bank-account company-bank-account-container"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountNumber"
        type="text"
        :disabled="true"
      >
        <template #append>
          <el-button
            :type="isMainOrangeEnabled ? 'secondary' : 'primary'"
            plain
            @click="
              copyTextToClipBoard(
                normalBankTransferDepositFormData.companyBankAccountNumber
              )
            "
          >
            {{ $t("copy") }}
          </el-button>
        </template>
      </el-input>
    </el-form-item>
    <div class="mt-10 text-center">
      <el-button
        v-if="isUploadImage"
        type="primary"
        :disabled="isUploadImage"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("waiting_upload_image") }}</el-button
      >
      <el-button
        v-else-if="isProccesing"
        type="primary"
        :disabled="isProccesing"
        class="w-[120px] h-[32px]"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
      <el-button
        v-else
        type="primary"
        class="w-[120px] h-[32px]"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
    </div>
  </el-form>
  <el-form
    ref="normalBankTransferDepositFormRef"
    status-icon
    label-position="top"
    :model="normalBankTransferDepositFormData"
    :rules="normalBankTransferDepositRules"
    label-width="210px"
    class="p-6 display-form-mobile"
    :validate-on-rule-change="false"
  >
    <div
      v-if="bankTransferDepositTextInfo?.Text.length > 0"
      class="mt-2 text-sm rounded bg-background5 --text4 font-normal"
      v-html="bankTransferDepositTextInfo?.Text"
    ></div>
    <h4 class="my-4 fc-primary">{{ $t("from") }}</h4>
    <h5 :class="theme === 'peru_green' ? 'text-color' : '--text4' ">{{ $t("bank") }}</h5>
    <div class="w-full pb-5" v-if="isFirstTimeDeposit">
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        group-name="peru-select-bank-name"
        class="flex flex-column flex-wrap gap-3 py-2 peru-select-bank"
      >
        <ui-radio-button
          v-for="player in playerBankOptions"
          :key="player.BankName"
          :label="player.BankName"
          :value="player.BankName"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!player.BankLogo || player.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="player.BankName"
          />
          <ui-check-button
            v-else
            style="--height: 3rem"
            :img="getImagePathBankLogo(player.BankLogo)"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <div class="w-full pb-5" v-else>
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        group-name="peru-select-bank-name"
        class="flex flex-column flex-wrap gap-3 py-2 peru-select-bank"
      >
        <ui-radio-button
          v-for="(bank, index) in playerBankAfterFirstTimeDeposit"
          :key="index"
          :label="bank.PlayerBankName"
          :value="bank.PlayerBankName"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!bank.BankLogo || bank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="bank.PlayerBankName"
          />
          <ui-check-button
            v-else
            style="--height: 3rem"
            :img="getImagePathBankLogo(bank.BankLogo)"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="
        normalBankTransferDepositFormData.selectedPlayerBankOption === 'Other'
      "
      :label="$t('bank_name')"
      prop="customizeBankName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.customizeBankName"
        type="text"
        v-un-focus
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.branchNameSetting"
      :label="$t('BranchName')"
      prop="branchName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.branchName"
        type="text"
        v-un-focus
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bankAccountNameSetting"
      :label="$t('bank_account_name')" 
      prop="bankAccountName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountName"
        type="text"
        v-un-focus
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNameEmpty
        "
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bankAccountNumberSetting"
      :label="$t('bank_account_number')" 
      prop="bankAccountNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountNumber"
        type="text"
        v-un-focus
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNumberEmpty
        "
        oninput="this.value = this.value.replace(/[^0-9]/g, '')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bsbSetting"
      :label="$t('BSB')"
      prop="bsb"
    >
      <el-input
        maxlength="6"
        v-model="normalBankTransferDepositFormData.bsb" id="depositBSB" 
        @input="onInputValue($event, normalBankTransferDepositFormData, 'bsb')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.payIdSetting"
      :label="$t('PayID')"
      prop="payId"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.payId" id="depositPayId" 
      />
    </el-form-item>
    <el-form-item :label="$t('amount')" prop="amount">
      <el-input
        v-model="normalBankTransferDepositFormData.amount"
        oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
        v-un-focus
        :placeholder="amountPlaceholder"
      >
        <template v-if="isNeedToMultiplyByThousand" #append>000</template>
      </el-input>
      <span
        v-if="isNeedToMultiplyByThousand"
        class="order-1 mt-3 text-xs fc-hint"
        >{{
          $t(
            `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}</span
      >
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.slipUploadSetting"
      :label="$t('slip_image')"
      prop="slipUpload"
    >
      <el-upload
        ref="uploadSlipImageFRef"
        v-model="normalBankTransferDepositFormData.slipUpload"
        class="w-full upload-demo"
        :limit="1"
        :on-exceed="handleSlipImageExceed"
        accept=".jpg, .png, .jpeg, .svg"
        :on-change="getSlipImage"
        :on-remove="removeSlipImage"
        :auto-upload="false"
      >
        <el-button plain round type="primary">
          {{ $t("choose_file") }}
        </el-button>
      </el-upload>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositTimeSetting"
      class="input-class"
      :label="$t('deposit_time')"
      prop="depositTime"
    >
      <el-date-picker
        v-model="normalBankTransferDepositFormData.depositTime"
        type="datetime"
        format="YYYY-MM-DD h:mm:ss A"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositReferenceNumberSetting"
      :label="$t('reference_number')"
      prop="depositReferenceNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.depositReferenceNumber"
        v-un-focus
        type="text"
      />
      <span
        v-if="selectedTheme === 'black'"
        class="order-1 mt-3 text-xs fc-hint"
        >{{ $t("reference_number_remark") }}</span
      >
    </el-form-item>
    <h4 class="mb-4 fc-primary">{{ $t("to") }}</h4>
    <h5 :class="theme === 'peru_green' ? 'text-color' : '--text4' ">{{ $t("company_bank") }}</h5>
    <div class="pb-5 w-full">
      <ui-radio-group
        v-model="selectedCompanyBankId"
        class="flex flex-column flex-wrap gap-3 peru-select-bank py-2"
        group-name="peru-select-company-bank-name"
      >
        <ui-radio-button
          v-for="companyBank in CompanyBanks"
          :key="companyBank.BankName"
          :label="companyBank.Id"
          :value="companyBank.Id"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!companyBank.BankLogo || companyBank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="companyBank.BankName"
          />
          <ui-check-button
            v-else
            :img="getImagePathBankLogo(companyBank.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="companyFlowSettings.companyBankAccountNameSetting"
      :label="$t('CompanyBankAccountName')"
      prop="companyBankAccountName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountName"
        type="text"
        :disabled="true"
      />
    </el-form-item>
    <el-form-item
      :label="$t('bank_account')"
      prop="companyBankAccountNumber"
      class="company-bank-account company-bank-account-container"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountNumber"
        type="text"
        :disabled="true"
      >
        <template #append>
          <el-button
            :type="isMainOrangeEnabled ? 'secondary' : 'primary'"
            plain
            @click="
              copyTextToClipBoard(
                normalBankTransferDepositFormData.companyBankAccountNumber
              )
            "
          >
            {{ $t("copy") }}
          </el-button>
        </template>
      </el-input>
    </el-form-item>
    <div class="mt-10 text-center">
      <el-button
        v-if="isUploadImage"
        type="primary"
        :disabled="isUploadImage"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("waiting_upload_image") }}</el-button
      >
      <el-button
        v-else-if="isProccesing"
        type="primary"
        :disabled="isProccesing"
        round
        class="greenperu__deposit-button w-[120px] h-[32px]"
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
      <el-button
        v-else
        type="primary"
        round
        class="greenperu__deposit-button w-[120px] h-[32px]"
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
    </div>
  </el-form>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { ProfileDto } from "@/models/getProfileResponse";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import themePropertyHelper from "@/utils/themePropertyHelper";
import depositBankImageHelper from "@/utils/depositBankImageHelper";

export default defineComponent({
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
      default: {} as IGetTransactionBankListResponse,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
      default: {} as ProfileDto,
    },
  },
  setup(props) {
    const { normalBanks, profile } = toRefs(props);
    const {
      getSlipImage,
      removeSlipImage,
      uploadSlipImageFRef,
      copyTextToClipBoard,
      handleSlipImageExceed,
      allowCompany,
    } = commonHelper;
    const { themeColor } = themePropertyHelper;
    const { getImagePathBankLogo } = depositBankImageHelper;
    const isMainOrangeEnabled = computed(
      (): boolean => themeColor.value.Text === "main_orange"
    );
    const selectedTheme = computed(() => store.state.selectedThemeName);
    const {
      selectedCompanyBankId,
      companyFlowSettings,
      isFirstTimeDeposit,
      playerBankOptions,
      CompanyBanks,
      playerBankAfterFirstTimeDeposit,
      normalBankTransferDepositRules,
      normalBankTransferDepositFormRef,
      normalBankTransferDepositFormData,
      slipUpload,
      isNeedToMultiplyByThousand,
      isProccesing,
      isUploadImage,
      submitDepositBankTransfer,
      amountPlaceholder,
      bankTransferDepositTextInfo,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    } = useNormalBankTransferDeposit(normalBanks, profile);
    const data = {
      selectedCompanyBankId,
      companyFlowSettings,
      isFirstTimeDeposit,
      playerBankOptions,
      CompanyBanks,
      playerBankAfterFirstTimeDeposit,
      normalBankTransferDepositRules,
      normalBankTransferDepositFormRef,
      normalBankTransferDepositFormData,
      submitDepositBankTransfer,
      copyTextToClipBoard,
      handleSlipImageExceed,
      uploadSlipImageFRef,
      getSlipImage,
      slipUpload,
      removeSlipImage,
      isNeedToMultiplyByThousand,
      isProccesing,
      isUploadImage,
      amountPlaceholder,
      bankTransferDepositTextInfo,
      profile,
      isMainOrangeEnabled,
      selectedTheme,
      getImagePathBankLogo,
      allowCompany,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    };
    return data;
  },
});
</script>
<style scoped>
:deep(.ui-radio-group.peru-select-bank .check-btn__img img) {
  max-height: 32px;
}
:deep(.ui-radio-group.peru-select-bank .check-btn__img) {
  max-width: max-content;
  display: block;
}
:deep(.ui-radio-group.peru-select-bank .ui-radio-button .check-btn__content) {
  padding-right: 16px;
}
:deep(.peru-select-bank .ui-radio-button.selected .check-btn__content) {
  padding-right: 40px;
}
@media screen and (max-width: 639px) {
  :deep(
      .ui-radio-group.peru-select-bank
        .ui-radio-button.selected
        .check-btn__text
    ) {
    padding-right: 16px;
  }
  :deep(
      .ui-radio-group.peru-select-bank .ui-radio-button.selected .check-btn__img
    ) {
    padding-right: 16px;
  }
}
</style>
<style lang="scss">
.display-form-mobile {
  display: none;
}
.display-form-desktop {
  display: block;
  border-bottom: none;
}
@media (max-width: 639px) {
  .display-form-mobile {
    display: block;
    overflow-y: scroll;
    height: calc(100vh - 110px);
  }
  .display-form-desktop {
    display: none;
  }
  div[theme-color="peru_green"] .greenperu__deposit-button {
    margin-bottom: 169px;
  }
}
</style>
